<template>
  <div class="flex flex-col space-y-2 shadow-filters-box items-center justify-center">
    <label class="hidden typo__label">Select with search</label>
    <multi-list-select
      :list="options"
      option-value="id"
      option-text="name"
      :id="name"
      :name="name"
      :selected-items="items"
      @select="onSelect"
      @searchchange="printSearchText"
      placeholder="Filtrer par"
      class="max-w-[261px] text-lg"
    >
    </multi-list-select>
    <button
      @click="applySelection"
      class="border border-white text-xl bg-las-orange text-white w-[150px] p-2 rounded-[150px] hover:bg-white hover:text-las-orange hover:border-las-orange hover:border">
        Appliquer
    </button>
    <button
      @click="reset"
      class="text-xl text-las-orange underline hover:no-underline"
    >
      Réinitialiser
    </button>
  </div>
</template>
<script>
  import { computed } from 'vue';
  import { MultiListSelect } from "vue-search-select"
  export default {
    components: {
      MultiListSelect
    },
    emits: ['selection'],
    data: () => ({
      searchText: '',
      items: [],
    }),
    setup: (props) => {
      const name = computed(() => {
        if (props.dataName) {
          return props.dataName
        }        
      });

      const options = computed(() => {
        if (props.dataOptions) {
          return props.dataOptions
        }
      });
      
      // Return
      return {
        name,
        options,
      }
    },
    props: {
      dataOptions: {
        type: Array,
        required: true
      },
      dataName: {
        type: String,
        required: true
      }
    },
    methods: {
      printSearchText (searchText) {
        this.searchText = searchText
      },
      onSelect (items) {
        this.items = items
      },
      reset () {
        this.items.length = 0;
      },
      applySelection () {
        this.$emit('selection', this.items, this.name);
      }
    }
  }
</script>
<style>
  @import 'vue-search-select/dist/VueSearchSelect.css';

  .ui.multiple.search.dropdown {
    margin-top: 0;
    padding: 4px 8px;
  }
  .ui.label {
    background-color: #e58252;
    color: white;
  }
  .ui.multiple.dropdown>.label i.icon.delete:before,
  .ui.multiple.dropdown>.label i.icon.delete:after {
    background-color: white;
  }
  .ui.selection.active.dropdown .menu {
    border-radius: 0 0 10px 10px;
  }
  .ui.selection.active.dropdown .menu > .item {
    background-color: #e58252;
    color: white;
    border: none;
  }
  .ui.selection.active.dropdown .menu>.item:hover {
    background-color: white;
    color: #e58252;
  }
</style>